/* --- The following code comes from c:\lcc\lib\wizard\dll.tpl. */

#include <windows.h>
#include <malloc.h>

/*------------------------------------------------------------------------
 Procedure:     LibMain ID:1
 Purpose:       Dll entry point.Called when a dll is loaded or
                unloaded by a process, and when new threads are
                created or destroyed.
 Input:         hDllInst: Instance handle of the dll
                fdwReason: event: attach/detach
                lpvReserved: not used
 Output:        The return value is used only when the fdwReason is
                DLL_PROCESS_ATTACH. True means that the dll has
                sucesfully loaded, False means that the dll is unable
                to initialize and should be unloaded immediately.
 Errors:
------------------------------------------------------------------------*/
BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // The DLL is being loaded for the first time by a given process.
            // Perform per-process initialization here.  If the initialization
            // is successful, return TRUE; if unsuccessful, return FALSE.


            break;
        case DLL_PROCESS_DETACH:
            // The DLL is being unloaded by a given process.  Do any
            // per-process clean up here, such as undoing what was done in
            // DLL_PROCESS_ATTACH.  The return value is ignored.


            break;
        case DLL_THREAD_ATTACH:
            // A thread is being created in a process that has already loaded
            // this DLL.  Perform any per-thread initialization here.  The
            // return value is ignored.

            break;
        case DLL_THREAD_DETACH:
            // A thread is exiting cleanly in a process that has already
            // loaded this DLL.  Perform any per-thread clean up here.  The
            // return value is ignored.

            break;
    }
    return TRUE;
}


__declspec(dllexport) int dllTDGSolve(double *a,double *b,double *c,double *d,
                                      double *n,double *x,double *bprime, double *dprime)
{
	int i;
	int N;
	double w;
	
	N = (int) *n;	
	
	bprime[N-1] = b[N-1];
	dprime[N-1] = d[N-1];
	
	for (i = N-2; i >= 0; --i)
		{
			w = c[i] / bprime[i+1];
			bprime[i] = b[i] - w * a[i+1];
			dprime[i] = d[i] - w * dprime[i+1];						
		}

    x[0] = dprime[0] / bprime[0];
	
	for (i = 1; i <= N-1; ++i)
		{			
			x[i] = (dprime[i] - a[i] * x[i-1]) / bprime[i];			
		}		
		
	return 0;
}
