/*
**> European Option Example
**
** When non-uniform grids do not work ?
**
** Mesh ratios
*/

new;
library PDE,pgraph;
PDEset;

#include option.src;

tmin =  0; tmax = 1; M = 51;
xmin = 50; xmax = 150;

N = seqa(50,3000/30,31);

h1 = zeros(rows(N),1);
h2 = zeros(rows(N),1);
h3 = zeros(rows(N),1);

i = 1;
do until i > rows(N); 
   y = generateGrid1(xmin,xmax,N[i]);
   h1[i,1] = minc(y - lag1(y));
   y = generateGrid3(xmin,xmax,N[i],100,20);
   h2[i,1] = minc(y - lag1(y));
   y = generateGrid3(xmin,xmax,N[i],100,2);
   h3[i,1] = minc(y - lag1(y));
   i = i+1;
endo;

k = 1/(M-1);
r1 = k./(h1^2);
r2 = k./(h2^2);
r3 = k./(h3^2);

graphset;
  _pdate = "";
  fonts("simplex simgrma");
  _pcross = 1; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3;   
  _plegstr = "Uniform grid\000Non-uniform grid (\202a\201 = 20)\000Non-uniform grid (\202a\201 = 2)";
  _plegctl = {2 5 5 3};
  xlabel("N");
  ylabel("mesh ratio r");
  xtics(0,3000,500,2);
  ytics(0,200,50,2);
  graphprt("-c=1 -cf=wrong2.ps");
  xy(N,r1~r2~r3);

 